Package: org.codehaus.groovy.classgen.asm.util

## [Java] Class LoggableTextifier

- org.codehaus.groovy.classgen.asm.util.LoggableTextifier

- Logging bytecode generation, which can make debugging easy

  Since:
    2.5.0

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class org.objectweb.asm.util.Textifier` | `INTERNAL_NAME, FIELD_DESCRIPTOR, FIELD_SIGNATURE, METHOD_DESCRIPTOR, METHOD_SIGNATURE, CLASS_SIGNATURE, TYPE_DECLARATION, CLASS_DECLARATION, PARAMETERS_DECLARATION, HANDLE_DESCRIPTOR, OPCODES, TYPES, HANDLE_TAG, text`
    `class org.objectweb.asm.util.Printer` | `OPCODES, TYPES, HANDLE_TAG, text`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `LoggableTextifier ()`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected org.objectweb.asm.util.Textifier` | `createTextifier()`
    `` | `protected void` | `log()`
    `` | `void` | `visit(int version, int access, String name, String signature, String superName, String[] interfaces)`
    `` | `void` | `visit(String name, Object value)`
    `` | `org.objectweb.asm.util.Textifier` | `visitAnnotation(String name, String desc)`
    `` | `org.objectweb.asm.util.Textifier` | `visitAnnotation(String desc, boolean visible)`
    `` | `org.objectweb.asm.util.Textifier` | `visitAnnotationDefault()`
    `` | `void` | `visitAnnotationEnd()`
    `` | `org.objectweb.asm.util.Textifier` | `visitArray(String name)`
    `` | `void` | `visitAttribute(org.objectweb.asm.Attribute attr)`
    `` | `org.objectweb.asm.util.Textifier` | `visitClassAnnotation(String desc, boolean visible)`
    `` | `void` | `visitClassAttribute(org.objectweb.asm.Attribute attr)`
    `` | `void` | `visitClassEnd()`
    `` | `org.objectweb.asm.util.Printer` | `visitClassTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `void` | `visitCode()`
    `` | `void` | `visitEnum(String name, String desc, String value)`
    `` | `void` | `visitExport(String export, int access, String... modules)`
    `` | `org.objectweb.asm.util.Textifier` | `visitField(int access, String name, String desc, String signature, Object value)`
    `` | `org.objectweb.asm.util.Textifier` | `visitFieldAnnotation(String desc, boolean visible)`
    `` | `void` | `visitFieldAttribute(org.objectweb.asm.Attribute attr)`
    `` | `void` | `visitFieldEnd()`
    `` | `void` | `visitFieldInsn(int opcode, String owner, String name, String desc)`
    `` | `org.objectweb.asm.util.Printer` | `visitFieldTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `void` | `visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)`
    `` | `void` | `visitIincInsn(int var, int increment)`
    `` | `void` | `visitInnerClass(String name, String outerName, String innerName, int access)`
    `` | `void` | `visitInsn(int opcode)`
    `` | `org.objectweb.asm.util.Printer` | `visitInsnAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `void` | `visitIntInsn(int opcode, int operand)`
    `` | `void` | `visitInvokeDynamicInsn(String name, String desc, org.objectweb.asm.Handle bsm, Object... bsmArgs)`
    `` | `void` | `visitJumpInsn(int opcode, org.objectweb.asm.Label label)`
    `` | `void` | `visitLabel(org.objectweb.asm.Label label)`
    `` | `void` | `visitLdcInsn(Object cst)`
    `` | `void` | `visitLineNumber(int line, org.objectweb.asm.Label start)`
    `` | `void` | `visitLocalVariable(String name, String desc, String signature, org.objectweb.asm.Label start, org.objectweb.asm.Label end, int index)`
    `` | `org.objectweb.asm.util.Printer` | `visitLocalVariableAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, org.objectweb.asm.Label[] start, org.objectweb.asm.Label[] end, int[] index, String desc, boolean visible)`
    `` | `void` | `visitLookupSwitchInsn(org.objectweb.asm.Label dflt, int[] keys, org.objectweb.asm.Label[] labels)`
    `` | `void` | `visitMaxs(int maxStack, int maxLocals)`
    `` | `org.objectweb.asm.util.Textifier` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)`
    `` | `org.objectweb.asm.util.Textifier` | `visitMethodAnnotation(String desc, boolean visible)`
    `` | `void` | `visitMethodAttribute(org.objectweb.asm.Attribute attr)`
    `` | `void` | `visitMethodEnd()`
    `` | `void` | `visitMethodInsn(int opcode, String owner, String name, String desc)`
    `` | `void` | `visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)`
    `` | `org.objectweb.asm.util.Printer` | `visitMethodTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `org.objectweb.asm.util.Printer` | `visitModule(String name, int access, String version)`
    `` | `void` | `visitModuleEnd()`
    `` | `void` | `visitMultiANewArrayInsn(String desc, int dims)`
    `` | `void` | `visitOuterClass(String owner, String name, String desc)`
    `` | `void` | `visitParameter(String name, int access)`
    `` | `org.objectweb.asm.util.Textifier` | `visitParameterAnnotation(int parameter, String desc, boolean visible)`
    `` | `void` | `visitProvide(String provide, String... providers)`
    `` | `void` | `visitRequire(String require, int access, String version)`
    `` | `void` | `visitSource(String file, String debug)`
    `` | `void` | `visitTableSwitchInsn(int min, int max, org.objectweb.asm.Label dflt, org.objectweb.asm.Label... labels)`
    `` | `org.objectweb.asm.util.Printer` | `visitTryCatchAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `void` | `visitTryCatchBlock(org.objectweb.asm.Label start, org.objectweb.asm.Label end, org.objectweb.asm.Label handler, String type)`
    `` | `org.objectweb.asm.util.Textifier` | `visitTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `void` | `visitTypeInsn(int opcode, String type)`
    `` | `void` | `visitUse(String use)`
    `` | `void` | `visitVarInsn(int opcode, int var)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class org.objectweb.asm.util.Textifier` | `org.objectweb.asm.util.Textifier#visitAnnotableParameterCount(int, boolean), org.objectweb.asm.util.Textifier#visitAnnotableParameterCount(int, boolean), org.objectweb.asm.util.Textifier#visitOpen(java.lang.String, int, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitRequire(java.lang.String, int, java.lang.String), org.objectweb.asm.util.Textifier#visitMainClass(java.lang.String), org.objectweb.asm.util.Textifier#visitProvide(java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitExport(java.lang.String, int, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitPackage(java.lang.String), org.objectweb.asm.util.Textifier#visitUse(java.lang.String), org.objectweb.asm.util.Textifier#visitNestHost(java.lang.String), org.objectweb.asm.util.Textifier#visitNestMember(java.lang.String), org.objectweb.asm.util.Textifier#visitClassEnd(), org.objectweb.asm.util.Textifier#visitMethodEnd(), org.objectweb.asm.util.Textifier#visitFieldEnd(), org.objectweb.asm.util.Textifier#visitAnnotationEnd(), org.objectweb.asm.util.Textifier#visitMethodAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitMethodAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitClassTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitMethodAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitFieldAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitFieldAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitClassAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitFieldAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitFieldTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitClassAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitClassAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitMethodTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitModuleEnd(), org.objectweb.asm.util.Textifier#visitFrame(int, int, [Ljava.lang.Object;, int, [Ljava.lang.Object;), org.objectweb.asm.util.Textifier#main([Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitParameter(java.lang.String, int), org.objectweb.asm.util.Textifier#visitAnnotationDefault(), org.objectweb.asm.util.Textifier#visitAnnotationDefault(), org.objectweb.asm.util.Textifier#visitParameterAnnotation(int, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitParameterAnnotation(int, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitInvokeDynamicInsn(java.lang.String, java.lang.String, org.objectweb.asm.Handle, [Ljava.lang.Object;), org.objectweb.asm.util.Textifier#visitIincInsn(int, int), org.objectweb.asm.util.Textifier#visitTableSwitchInsn(int, int, org.objectweb.asm.Label, [Lorg.objectweb.asm.Label;), org.objectweb.asm.util.Textifier#visitLookupSwitchInsn(org.objectweb.asm.Label, [I, [Lorg.objectweb.asm.Label;), org.objectweb.asm.util.Textifier#visitMultiANewArrayInsn(java.lang.String, int), org.objectweb.asm.util.Textifier#visitInsnAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitTryCatchAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitLocalVariable(java.lang.String, java.lang.String, java.lang.String, org.objectweb.asm.Label, org.objectweb.asm.Label, int), org.objectweb.asm.util.Textifier#visitLocalVariableAnnotation(int, org.objectweb.asm.TypePath, [Lorg.objectweb.asm.Label;, [Lorg.objectweb.asm.Label;, [I, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitLineNumber(int, org.objectweb.asm.Label), org.objectweb.asm.util.Textifier#visitEnum(java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitArray(java.lang.String), org.objectweb.asm.util.Textifier#visitArray(java.lang.String), org.objectweb.asm.util.Textifier#visit(int, int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visit(java.lang.String, java.lang.Object), org.objectweb.asm.util.Textifier#visitSource(java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitMethod(int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitMethod(int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitMaxs(int, int), org.objectweb.asm.util.Textifier#visitInsn(int), org.objectweb.asm.util.Textifier#visitLdcInsn(java.lang.Object), org.objectweb.asm.util.Textifier#visitIntInsn(int, int), org.objectweb.asm.util.Textifier#visitVarInsn(int, int), org.objectweb.asm.util.Textifier#visitMethodInsn(int, java.lang.String, java.lang.String, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitMethodInsn(int, java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitTypeInsn(int, java.lang.String), org.objectweb.asm.util.Textifier#visitAnnotation(java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitAnnotation(java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitFieldInsn(int, java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitJumpInsn(int, org.objectweb.asm.Label), org.objectweb.asm.util.Textifier#visitLabel(org.objectweb.asm.Label), org.objectweb.asm.util.Textifier#visitTryCatchBlock(org.objectweb.asm.Label, org.objectweb.asm.Label, org.objectweb.asm.Label, java.lang.String), org.objectweb.asm.util.Textifier#visitField(int, java.lang.String, java.lang.String, java.lang.String, java.lang.Object), org.objectweb.asm.util.Textifier#visitField(int, java.lang.String, java.lang.String, java.lang.String, java.lang.Object), org.objectweb.asm.util.Textifier#visitCode(), org.objectweb.asm.util.Textifier#visitModule(java.lang.String, int, java.lang.String), org.objectweb.asm.util.Textifier#visitOuterClass(java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitInnerClass(java.lang.String, java.lang.String, java.lang.String, int), org.objectweb.asm.util.Textifier#getText(), org.objectweb.asm.util.Textifier#appendString(java.lang.StringBuilder, java.lang.String), org.objectweb.asm.util.Textifier#appendString(java.lang.StringBuffer, java.lang.String), org.objectweb.asm.util.Textifier#print(java.io.PrintWriter), org.objectweb.asm.util.Textifier#wait(long), org.objectweb.asm.util.Textifier#wait(long, int), org.objectweb.asm.util.Textifier#wait(), org.objectweb.asm.util.Textifier#equals(java.lang.Object), org.objectweb.asm.util.Textifier#toString(), org.objectweb.asm.util.Textifier#hashCode(), org.objectweb.asm.util.Textifier#getClass(), org.objectweb.asm.util.Textifier#notify(), org.objectweb.asm.util.Textifier#notifyAll()`
    `class org.objectweb.asm.util.Printer` | `org.objectweb.asm.util.Printer#getText(), org.objectweb.asm.util.Printer#visitAnnotableParameterCount(int, boolean), org.objectweb.asm.util.Printer#visitOpen(java.lang.String, int, [Ljava.lang.String;), org.objectweb.asm.util.Printer#visitRequire(java.lang.String, int, java.lang.String), org.objectweb.asm.util.Printer#visitMainClass(java.lang.String), org.objectweb.asm.util.Printer#visitProvide(java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Printer#visitExport(java.lang.String, int, [Ljava.lang.String;), org.objectweb.asm.util.Printer#visitPackage(java.lang.String), org.objectweb.asm.util.Printer#visitUse(java.lang.String), org.objectweb.asm.util.Printer#visitNestHost(java.lang.String), org.objectweb.asm.util.Printer#visitNestMember(java.lang.String), org.objectweb.asm.util.Printer#visitClassEnd(), org.objectweb.asm.util.Printer#visitMethodEnd(), org.objectweb.asm.util.Printer#visitFieldEnd(), org.objectweb.asm.util.Printer#appendString(java.lang.StringBuilder, java.lang.String), org.objectweb.asm.util.Printer#appendString(java.lang.StringBuffer, java.lang.String), org.objectweb.asm.util.Printer#visitAnnotationEnd(), org.objectweb.asm.util.Printer#visitMethodAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Printer#visitClassTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitMethodAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Printer#visitFieldAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Printer#visitClassAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Printer#visitFieldAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Printer#visitFieldTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitClassAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Printer#visitMethodTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitModuleEnd(), org.objectweb.asm.util.Printer#visitFrame(int, int, [Ljava.lang.Object;, int, [Ljava.lang.Object;), org.objectweb.asm.util.Printer#print(java.io.PrintWriter), org.objectweb.asm.util.Printer#visitParameter(java.lang.String, int), org.objectweb.asm.util.Printer#visitAnnotationDefault(), org.objectweb.asm.util.Printer#visitParameterAnnotation(int, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitInvokeDynamicInsn(java.lang.String, java.lang.String, org.objectweb.asm.Handle, [Ljava.lang.Object;), org.objectweb.asm.util.Printer#visitIincInsn(int, int), org.objectweb.asm.util.Printer#visitTableSwitchInsn(int, int, org.objectweb.asm.Label, [Lorg.objectweb.asm.Label;), org.objectweb.asm.util.Printer#visitLookupSwitchInsn(org.objectweb.asm.Label, [I, [Lorg.objectweb.asm.Label;), org.objectweb.asm.util.Printer#visitMultiANewArrayInsn(java.lang.String, int), org.objectweb.asm.util.Printer#visitInsnAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitTryCatchAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitLocalVariable(java.lang.String, java.lang.String, java.lang.String, org.objectweb.asm.Label, org.objectweb.asm.Label, int), org.objectweb.asm.util.Printer#visitLocalVariableAnnotation(int, org.objectweb.asm.TypePath, [Lorg.objectweb.asm.Label;, [Lorg.objectweb.asm.Label;, [I, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitLineNumber(int, org.objectweb.asm.Label), org.objectweb.asm.util.Printer#visitEnum(java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Printer#visitArray(java.lang.String), org.objectweb.asm.util.Printer#visit(int, int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Printer#visit(java.lang.String, java.lang.Object), org.objectweb.asm.util.Printer#visitSource(java.lang.String, java.lang.String), org.objectweb.asm.util.Printer#visitMethod(int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Printer#visitMaxs(int, int), org.objectweb.asm.util.Printer#visitInsn(int), org.objectweb.asm.util.Printer#visitLdcInsn(java.lang.Object), org.objectweb.asm.util.Printer#visitIntInsn(int, int), org.objectweb.asm.util.Printer#visitVarInsn(int, int), org.objectweb.asm.util.Printer#visitMethodInsn(int, java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Printer#visitMethodInsn(int, java.lang.String, java.lang.String, java.lang.String, boolean), org.objectweb.asm.util.Printer#visitTypeInsn(int, java.lang.String), org.objectweb.asm.util.Printer#visitAnnotation(java.lang.String, java.lang.String), org.objectweb.asm.util.Printer#visitFieldInsn(int, java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Printer#visitJumpInsn(int, org.objectweb.asm.Label), org.objectweb.asm.util.Printer#visitLabel(org.objectweb.asm.Label), org.objectweb.asm.util.Printer#visitTryCatchBlock(org.objectweb.asm.Label, org.objectweb.asm.Label, org.objectweb.asm.Label, java.lang.String), org.objectweb.asm.util.Printer#visitField(int, java.lang.String, java.lang.String, java.lang.String, java.lang.Object), org.objectweb.asm.util.Printer#visitCode(), org.objectweb.asm.util.Printer#visitModule(java.lang.String, int, java.lang.String), org.objectweb.asm.util.Printer#visitOuterClass(java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Printer#visitInnerClass(java.lang.String, java.lang.String, java.lang.String, int), org.objectweb.asm.util.Printer#wait(long), org.objectweb.asm.util.Printer#wait(long, int), org.objectweb.asm.util.Printer#wait(), org.objectweb.asm.util.Printer#equals(java.lang.Object), org.objectweb.asm.util.Printer#toString(), org.objectweb.asm.util.Printer#hashCode(), org.objectweb.asm.util.Printer#getClass(), org.objectweb.asm.util.Printer#notify(), org.objectweb.asm.util.Printer#notifyAll()`

- - ### Constructor Detail

    - #### public LoggableTextifier()

  - ### Method Detail

    - #### @Override protected org.objectweb.asm.util.Textifier createTextifier()

    - #### protected void log()

    - #### @Override public void visit(int version, int access, String name, String signature, String superName, String[] interfaces)

    - #### @Override public void visit(String name, Object value)

    - #### @Override public org.objectweb.asm.util.Textifier visitAnnotation(String name, String desc)

    - #### @Override public org.objectweb.asm.util.Textifier visitAnnotation(String desc, boolean visible)

    - #### @Override public org.objectweb.asm.util.Textifier visitAnnotationDefault()

    - #### @Override public void visitAnnotationEnd()

    - #### @Override public org.objectweb.asm.util.Textifier visitArray(String name)

    - #### @Override public void visitAttribute(org.objectweb.asm.Attribute attr)

    - #### @Override public org.objectweb.asm.util.Textifier visitClassAnnotation(String desc, boolean visible)

    - #### @Override public void visitClassAttribute(org.objectweb.asm.Attribute attr)

    - #### @Override public void visitClassEnd()

    - #### @Override public org.objectweb.asm.util.Printer visitClassTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### @Override public void visitCode()

    - #### @Override public void visitEnum(String name, String desc, String value)

    - #### @Override public void visitExport(String export, int access, String... modules)

    - #### @Override public org.objectweb.asm.util.Textifier visitField(int access, String name, String desc, String signature, Object value)

    - #### @Override public org.objectweb.asm.util.Textifier visitFieldAnnotation(String desc, boolean visible)

    - #### @Override public void visitFieldAttribute(org.objectweb.asm.Attribute attr)

    - #### @Override public void visitFieldEnd()

    - #### @Override public void visitFieldInsn(int opcode, String owner, String name, String desc)

    - #### @Override public org.objectweb.asm.util.Printer visitFieldTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### @Override public void visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)

    - #### @Override public void visitIincInsn(int var, int increment)

    - #### @Override public void visitInnerClass(String name, String outerName, String innerName, int access)

    - #### @Override public void visitInsn(int opcode)

    - #### @Override public org.objectweb.asm.util.Printer visitInsnAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### @Override public void visitIntInsn(int opcode, int operand)

    - #### @Override public void visitInvokeDynamicInsn(String name, String desc, org.objectweb.asm.Handle bsm, Object... bsmArgs)

    - #### @Override public void visitJumpInsn(int opcode, org.objectweb.asm.Label label)

    - #### @Override public void visitLabel(org.objectweb.asm.Label label)

    - #### @Override public void visitLdcInsn(Object cst)

    - #### @Override public void visitLineNumber(int line, org.objectweb.asm.Label start)

    - #### @Override public void visitLocalVariable(String name, String desc, String signature, org.objectweb.asm.Label start, org.objectweb.asm.Label end, int index)

    - #### @Override public org.objectweb.asm.util.Printer visitLocalVariableAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, org.objectweb.asm.Label[] start, org.objectweb.asm.Label[] end, int[] index, String desc, boolean visible)

    - #### @Override public void visitLookupSwitchInsn(org.objectweb.asm.Label dflt, int[] keys, org.objectweb.asm.Label[] labels)

    - #### @Override public void visitMaxs(int maxStack, int maxLocals)

    - #### @Override public org.objectweb.asm.util.Textifier visitMethod(int access, String name, String desc, String signature, String[] exceptions)

    - #### @Override public org.objectweb.asm.util.Textifier visitMethodAnnotation(String desc, boolean visible)

    - #### @Override public void visitMethodAttribute(org.objectweb.asm.Attribute attr)

    - #### @Override public void visitMethodEnd()

    - #### @Override public void visitMethodInsn(int opcode, String owner, String name, String desc)

    - #### @Override public void visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)

    - #### @Override public org.objectweb.asm.util.Printer visitMethodTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### @Override public org.objectweb.asm.util.Printer visitModule(String name, int access, String version)

    - #### @Override public void visitModuleEnd()

    - #### @Override public void visitMultiANewArrayInsn(String desc, int dims)

    - #### @Override public void visitOuterClass(String owner, String name, String desc)

    - #### @Override public void visitParameter(String name, int access)

    - #### @Override public org.objectweb.asm.util.Textifier visitParameterAnnotation(int parameter, String desc, boolean visible)

    - #### @Override public void visitProvide(String provide, String... providers)

    - #### @Override public void visitRequire(String require, int access, String version)

    - #### @Override public void visitSource(String file, String debug)

    - #### @Override public void visitTableSwitchInsn(int min, int max, org.objectweb.asm.Label dflt, org.objectweb.asm.Label... labels)

    - #### @Override public org.objectweb.asm.util.Printer visitTryCatchAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### @Override public void visitTryCatchBlock(org.objectweb.asm.Label start, org.objectweb.asm.Label end, org.objectweb.asm.Label handler, String type)

    - #### @Override public org.objectweb.asm.util.Textifier visitTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### @Override public void visitTypeInsn(int opcode, String type)

    - #### @Override public void visitUse(String use)

    - #### @Override public void visitVarInsn(int opcode, int var)